<script lang="ts" setup>
import { computed } from 'vue';
import type { Carousel } from './Carousel.vue';
const { isMobile } = useCheckIfMobile();

interface Section {
  title: string;
  text: string;
  mobileSubtitle?: string;
  config: {
    imgSrc?: string;
    demographicsSection?: boolean;
    resultsFile: string;
  };
  label?: string;
  subsections: Array<Subsection>;
}

interface Subsection {
  subtext?: string;
  config?: {
    inverse?: boolean;
    mobileOnly?: boolean;
    imgVariant?: number;
  };
  data?: {
    type: string;
    config: { type: string };
    resultsLabel: string;
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    results: Array<any>; // explicitly setting any due to complexity of translated property names and the amount of variances between results arrays
    carousel?: Carousel;
  };
  textBlocks?: Array<{
    title: string;
    text: string;
  }>;
  callOutBox?: {
    text: string;
    stat?: {
      number: number;
      config: {
        color: string;
      };
    };
  };
}

const props = defineProps({
  data: {
    type: Object as () => Section,
    required: true,
    default: () => {},
  },
});

const anchorID = (string: string) => {
  return toKebabCase(string);
};

const leftDemoColumn = computed(() => props.data.subsections[0]?.data?.results?.slice(0, 3) || []);
const rightDemoColumn = computed(() => props.data.subsections[0]?.data?.results?.slice(3, 6) || []);

const bubbleStyle = (value: number, color: string) => {
  const size = value * 2;
  return {
    width: `${size}px`,
    height: `${size}px`,
    lineHeight: `${size}px`,
    backgroundColor: color,
  };
};
</script>

<template>
  <section class="section" :class="data.config?.demographicsSection ? 'gradient' : ''">
    <SlpContainer>
      <div class="section__header">
        <div class="content-wrapper">
          <SlpTypography
            v-if="!data.config?.demographicsSection"
            :id="`${anchorID(data.title)}-label`"
            tag="p"
            class="label"
          >
            {{ data.mobileSubtitle }}
          </SlpTypography>
          <SlpTypography
            :id="`${anchorID(data.title)}`"
            tag="h2"
            :data-aos="data.config?.demographicsSection ? 'fade-up' : ''"
            :data-aos-duration="500"
            :variant="data.config?.demographicsSection ? 'heading1-bold' : 'heading2-bold'"
            :aria-labelledby="`${anchorID(data.title)}-label`"
          >
            {{ data.title }}
          </SlpTypography>
          <SlpTypography tag="div" variant="body2" class="slp-mt-8 subsection-text">
            <div v-html="$md.render(data.text)" />
          </SlpTypography>
        </div>
        <div
          v-if="data.config?.imgSrc"
          :class="data.config?.demographicsSection ? 'image-wrapper demographics' : 'image-wrapper'"
        >
          <img
            :src="data.config?.imgSrc"
            alt=""
            :data-aos="data.config?.demographicsSection ? 'fade-left' : 'fade-up'"
            :data-aos-duration="500"
            loading="lazy"
          />
        </div>
      </div>

      <div v-for="subsection in data.subsections" :key="subsection.subtext" class="subsection">
        <div v-if="subsection.subtext" class="subsection__header">
          <Devsurvey2024Header
            :header="data.label"
            :text="subsection.subtext"
            :img-variant="subsection.config?.imgVariant"
          />
        </div>
        <div :class="['subsection__content', subsection.config?.inverse ? 'inverse' : '']">
          <div
            class="report"
            v-bind="
              !isMobile
                ? {
                    'data-aos': subsection.config?.inverse ? 'fade-left' : 'fade-right',
                    'data-aos-duration': '700',
                    'data-aos-offset': '100',
                  }
                : {}
            "
          >
            <!-- Accordion and Content Logic -->
            <Devsurvey2024Accordion
              v-if="subsection.data && subsection.data.config?.type === 'radio'"
              :data="subsection.data.resultsLabel"
              background-color="#F6F3FE"
              :open-by-default="isMobile"
            >
              <Devsurvey2024Carousel
                v-if="subsection.data.results.length > 1"
                :data="subsection.data.carousel"
                controls-on-top
                :components="{ type: 'Devsurvey2024ResultsRadio', data: subsection.data.results }"
              />

              <Devsurvey2024ResultsRadio v-else :data="subsection.data.results" />
            </Devsurvey2024Accordion>
            <!-- Bubble Tables -->
            <Devsurvey2024Accordion
              v-if="subsection.data && subsection.data.config?.type === 'bubble_table'"
              :data="subsection.data.resultsLabel"
              background-color="#F6F3FE"
              :open-by-default="isMobile"
              :mobile-only="data.config?.demographicsSection"
            >
              <Devsurvey2024Carousel
                v-if="subsection.data.results.length > 1"
                :data="subsection.data.carousel"
                controls-on-top
                :components="{
                  type: 'Devsurvey2024BubbleTable',
                  data: subsection.data.results,
                }"
              />

              <Devsurvey2024BubbleTable v-else :data="subsection.data.results" />
            </Devsurvey2024Accordion>

            <div v-if="data.config.demographicsSection" class="demographics-results-desktop">
              <div class="column">
                <Devsurvey2024BubbleTable
                  v-for="table in leftDemoColumn"
                  :key="table.header"
                  :data="table"
                  class="demographics-table"
                />
              </div>
              <div class="column">
                <Devsurvey2024BubbleTable
                  v-for="table in rightDemoColumn"
                  :key="table.header"
                  :data="table"
                  class="demographics-table"
                />
              </div>
            </div>

            <!-- Text-only Results -->
            <Devsurvey2024Accordion
              v-if="subsection.data && subsection.data.config.type === 'text_only'"
              :data="subsection.data.resultsLabel"
              background-color="#F6F3FE"
              :open-by-default="isMobile"
            >
              <Devsurvey2024Carousel
                v-if="subsection.data.results.length > 1"
                :data="subsection.data.carousel"
                controls-on-top
                :components="{
                  type: 'Devsurvey2024TextResults',
                  data: subsection.data.results,
                }"
              />
              <Devsurvey2024TextResults v-else :data="subsection.data.results" />
            </Devsurvey2024Accordion>
            <!-- Handles that late addon instance of multiple component types within a carousel -->
            <Devsurvey2024Accordion
              v-if="subsection.data && subsection.data.config?.type === 'multiple'"
              :data="subsection.data.resultsLabel"
              background-color="#F6F3FE"
              :open-by-default="isMobile"
            >
              <Devsurvey2024Carousel
                :data="subsection.data.carousel"
                controls-on-top
                :components="{
                  data: subsection.data.results,
                }"
              />
            </Devsurvey2024Accordion>
          </div>
          <!-- Text blocks  -->
          <div
            v-if="subsection.textBlocks"
            class="text-blocks"
            v-bind="
              !isMobile
                ? {
                    'data-aos': subsection.config?.inverse ? 'fade-right' : 'fade-left',
                    'data-aos-duration': '700',
                    'data-aos-offset': '100',
                  }
                : {}
            "
          >
            <div v-if="subsection.callOutBox" class="call-out-box" :class="subsection.callOutBox.stat ? 'flex' : ''">
              <div>
                <p>{{ subsection.callOutBox.text }}</p>
              </div>
              <div
                v-if="subsection.callOutBox.stat"
                class="bubble"
                :style="bubbleStyle(subsection.callOutBox.stat.number, subsection.callOutBox.stat.config.color)"
              >
                {{ subsection.callOutBox.stat.number }}%
              </div>
            </div>
            <Devsurvey2024Accordion
              v-for="(block, index) in subsection.textBlocks"
              :key="block.text"
              :class="`${subsection.config?.mobileOnly ? 'mobile-only' : ''}`"
              :data="{ title: block.title, text: block.text }"
              :is-desktop-accordion="subsection.textBlocks.length > 1"
              :open-by-default="!isMobile && subsection.textBlocks.length > 1 && index == 0"
            />
          </div>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.section {
  padding: 64px 0;
  position: relative;
  color: #232150;

  @media (max-width: $breakpoint-md) {
    padding: 16px 0;
  }

  &.gradient {
    background: linear-gradient(0deg, #d7fefe 0.45%, #f2f1f5 99.68%);

    &:before {
      @media (min-width: $breakpoint-lg) {
        content: '';
        background: url('/images/developer-survey/2024/2024-survey-hero-bg-pills.png');
        background-size: contain;
        background-repeat: no-repeat;
        position: absolute;
        top: -2%;
        left: 20%;
        z-index: 0;
        width: 3000px;
        height: 600px;
      }
    }

    .subsection-text {
      @media (max-width: $breakpoint-md) {
        display: none;
      }
    }

    .content-wrapper {
      h2 {
        display: block;
        margin-bottom: 24px;
      }
    }

    &:deep(.survey-accordion) {
      @media (min-width: $breakpoint-md) {
        display: none;
      }
    }

    .subsection__content {
      width: 100%;

      @media (min-width: $breakpoint-md) {
        display: block;
      }
    }
  }

  &__header {
    padding-top: 32px;
    color: #232150;
    position: relative;
    text-align: left;
    display: flex;
    align-items: flex-start;
    z-index: 5;

    @media (max-width: $breakpoint-md) {
      padding-bottom: 32px;
      flex-direction: column-reverse;
      gap: 32px;
      padding-top: 0;
    }

    .content-wrapper {
      flex: 0 0 60%;
      max-width: 600px;
      padding-right: 48px;

      @media (max-width: $breakpoint-md) {
        flex: 1 0 100%;
        padding-right: 0;
      }

      &:deep(p),
      &:deep(li) {
        font-size: 18px;
      }

      &:deep(ol),
      &:deep(ul) {
        padding-left: 1.25em;
      }

      &:deep(li) {
        margin-bottom: 8px;
        list-style-type: disc;
      }

      &:deep(p) {
        margin-bottom: 8px;
        display: block;
      }

      &:deep(strong) {
        font-weight: $font-weight-bold;
      }
    }

    .image-wrapper:not(.demographics) {
      position: relative;
      flex: 1 0 40%;

      img {
        width: 100%;
        padding-left: 24px;

        @media (max-width: $breakpoint-md) {
          width: 100%;
          max-width: 100%;
          padding-left: 0;
        }
      }
    }

    .image-wrapper.demographics {
      img {
        width: 65%;
        z-index: -1;
        position: absolute;
        right: -8%;
        top: 14px;
      }

      @media (max-width: $breakpoint-md) {
        display: none;
      }
    }

    .label {
      font-size: 14px;
      font-weight: $font-weight-bold;
      line-height: 32px;
      margin-bottom: 8px;
    }
  }
}

.subsection {
  padding: 96px 0;

  @media (max-width: $breakpoint-md) {
    padding: 32px 0;
  }

  &__content {
    display: flex;
    flex-direction: row;
    gap: 32px;

    &.inverse {
      @media (min-width: $breakpoint-lg) {
        flex-direction: row-reverse;
      }
    }

    @media (max-width: $breakpoint-md) {
      flex-direction: column-reverse;
      gap: 8px;
    }

    .text-blocks,
    .report {
      width: 100%;
      flex: 0 1 50%;
    }

    .text-blocks {
      display: flex;
      flex-direction: column;
      gap: 8px;
    }
  }
}

.call-out-box {
  background: #f6f3fe;
  color: #232150;
  padding: 24px;
  font-size: 16px;
  border-radius: 8px;
  box-shadow: 0px 1px 4px 0px rgba(0, 0, 0, 0.1);
  margin-bottom: 8px;
  font-weight: $font-weight-bold;

  &.flex {
    display: flex;
    align-items: center;
  }

  .bubble {
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 50%;
    color: #232150;
    font-family: 'GitLab Mono';
    text-align: center;
    font-size: 24px;
    flex: 0 0 25%;
    // transform: scale(0); Uncomment this once the intersection observer is set up
    transition: transform 0.8s ease-out;

    @media (prefers-reduced-motion: reduce) {
      transition: none;
    }

    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }

  .bubble-visible {
    transform: scale(1);
  }
}

.demographics-results-desktop {
  display: flex;
  width: 100%;
  gap: 32px;

  @media (max-width: $breakpoint-md) {
    display: none;
  }

  .column {
    width: calc(50% - 32px);

    &:first-of-type {
      margin-top: 196px;
    }
  }

  .demographics-table {
    background: $color-surface-800;
    padding: 20px;
    color: #232150;
    border-radius: 8px;
    margin-bottom: 32px;
    box-shadow: 0px 1px 4px 0px rgba(0, 0, 0, 0.1);
  }
}

.mobile-only {
  @media (min-width: $breakpoint-lg) {
    display: none;
  }
}
</style>
